package com.nisum.offertransactionservice.util;

import com.nisum.offertransactionservice.genericexception.GlobalApiGenericException;
import com.safeway.epe.model.Response;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.reactive.function.client.ClientResponse;
import reactor.core.publisher.Mono;


@Slf4j
public class ExceptionUtil {

    private ExceptionUtil(){
        throw new GlobalApiGenericException();
    }

    public static Mono<Throwable> handleError(ClientResponse clientResponse) {
        final Mono<Response> responseMono = clientResponse.bodyToMono(Response.class);
        return  responseMono.flatMap(ExceptionUtil::apply);
    }

    private static Mono<? extends Throwable> apply(Response response) {
        log.error("Error Response While Calling Service {}", response);
        throw new GlobalApiGenericException(response, response.getHttpStatusCode());
    }

}
